import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import javax.script.ScriptException;
import org.python.jsr223.PyScriptEngine;
import org.python.jsr223.PyScriptEngineFactory;
import org.python.core.PySystemState;
import org.python.core.Py;


public class mem_test {
	public static void testScriptingLeakDetail() throws InterruptedException {
		ExecutorService pool = Executors.newSingleThreadExecutor();

		int i = 0;
		while (true) {
		    i++;
		    if (i % 500 == 0) {
				System.out.println((Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory())/(1024.0*1024.0));
				System.out.println("sysClosers: "+Py.getSystemState().sysClosers.size());
		        System.out.println("Iteration " + i+"\n");
				System.gc();
		    }

		    pool.submit(new Runnable() {
		        @Override
		        public void run() {
		            PyScriptEngineFactory factory = new PyScriptEngineFactory();
		            PyScriptEngine engine = (PyScriptEngine) factory.getScriptEngine();
		            try {
		                engine.eval("s = 'hello' + ' world'");
		            } catch (ScriptException e) {
		            }
		        }
		    });
		    Thread.sleep(10);
		}
	}

	public static void main(String[] args) {
		try {
			testScriptingLeakDetail();
		} catch (InterruptedException ie) {}
	}
}
